Attribute VB_Name = "mod_autosize"
'************************************
'PRIVATE DATA TYPES
'************************************
    '------------------------------------------
    'QUICK REPLACEMENT FOR AN OBJECT
    'DATA TYPE, HOLDS ALL NECESSARY
    'DATA
    '------------------------------------------
    Private Type objectinfo
        top As Long
        left As Long
        height As Long
        width As Long
        tag As String
    End Type

'************************************
'PRIVATE DATA TYPES
'************************************
    '------------------------------------------
    'AUTOSIZE SUB
    'OBJECT TAG CONTROLS
    'STRETCHH - STRETHCHES HORIZONTALLY
    'STRETCHV - STRETCHES VERTICALLY
    'STRETCHALL - STRETCHES BOTH HORIZONTAL AND VERTICAL
    'MOVEH - MOVES THE OBJECT HORIZONTAL
    'MOVEV - MOVES THE OBJECT VERTICAL
    'MOVEALL - MOVES THE OBJECT BOTH HORIZONTAL AND VERTICAL
    '------------------------------------------
    Public Sub Autosizeform(sizeform As Form, Optional forcereset As Boolean)
        If sizeform.WindowState = vbMinimized Then Exit Sub
        Dim getobject As Object             'CURRENT OBJECT BEING RETRIEVED
        Dim setobject As Integer            'CURRENT OBJECT BEING RESCALED
        Static noofobjects As Integer       'NUMBER OF OBJECTS FOUND ON THE FORM
        Static sizeobjects() As objectinfo  'STORES POSITIONS AND SIZE OF OBJECTS
                                            'USING OBJECT DATA TYPE WOULD SIMPLY
                                            'WASTE MEMORY
        Static effectobjects() As Object    'THIS IS THE ARRAY THAT WILL BE
                                            'MODIFIED WHEN SCALING THE OBJECTS
        Static firstheight As Long          'THE ORIGINAL HEIGHT OF THE FORM
        Static firstwidth As Long           'THE ORIGINAL WIDTH OF THE FORM
        
        '------------------------------------------
        'THIS BIT RESETS ALL THE SAVED INFORMATION
        'IF NO PREVIOUSLY FOUND OBJECTS WERE FOUND
        'AND IF THE FORCERESET FLAG IS HIGH
        If noofobjects = 0 Or forcereset Then
            For Each getobject In sizeform
                If getobject.tag <> "" Then
                    '-------------------------------------------
                    'INCREASE THE NUMBER OF FOUND OBJECTS
                    noofobjects = noofobjects + 1
                    '-------------------------------------------
                    'REDIM AND SAVE THE OBJECT POSITIONS TO
                    'THE NEW NUMBER OF OBJECTS FOUND
                    ReDim Preserve sizeobjects(noofobjects)
                    sizeobjects(noofobjects).top = getobject.top
                    sizeobjects(noofobjects).left = getobject.left
                    sizeobjects(noofobjects).width = getobject.width
                    sizeobjects(noofobjects).height = getobject.height
                    sizeobjects(noofobjects).tag = getobject.tag
                    '-------------------------------------------
                    'REDIM THE EFFECT OBJECTS AND SET THE
                    'NEW FOUND OBJECT
                    ReDim Preserve effectobjects(noofobjects)
                    Set effectobjects(noofobjects) = getobject
                    '-------------------------------------------
                End If
            Next
            '-------------------------------------------
            'GET THE ORIGINAL HEIGHT AND WIDTH OF THE
            'FORM BEING AUTOSIZED
            firstheight = sizeform.height
            firstwidth = sizeform.width
            '-------------------------------------------
        End If
        '------------------------------------------
        
        '------------------------------------------
        'THIS BIT LOOKS AT THE TAG PART OF THE SAVED
        'OBJECTS AND SCALES THEM AS NECESSARY
        'NO SCALING ALGORYTHMS ARE ACTUALLY USED,
        'THE ROUTINE WORKS BE KEEPING THE RIGHTHAND
        'GAP THE SAME
        If noofobjects >= 1 Then
            For setobject = 1 To noofobjects
                If sizeobjects(setobject).tag <> "" Then effectobjects(setobject).Visible = False
                Select Case sizeobjects(setobject).tag
                    Case "STRETCHH"
                        effectobjects(setobject).width = sizeform.width - (firstwidth - (sizeobjects(setobject).left + sizeobjects(setobject).width)) - sizeobjects(setobject).left
                    Case "STRETCHV"
                        effectobjects(setobject).height = sizeform.height - (firstheight - (sizeobjects(setobject).top + sizeobjects(setobject).height)) - sizeobjects(setobject).top
                    Case "STRETCHALL"
                        effectobjects(setobject).width = sizeform.width - (firstwidth - (sizeobjects(setobject).left + sizeobjects(setobject).width)) - sizeobjects(setobject).left
                        effectobjects(setobject).height = sizeform.height - (firstheight - (sizeobjects(setobject).top + sizeobjects(setobject).height)) - sizeobjects(setobject).top
                    Case "MOVEH"
                        effectobjects(setobject).left = sizeform.width - (firstwidth - sizeobjects(setobject).left)
                    Case "MOVEV"
                        effectobjects(setobject).top = sizeform.height - (firstheight - sizeobjects(setobject).top)
                    Case "MOVEALL"
                        effectobjects(setobject).left = sizeform.width - (firstwidth - sizeobjects(setobject).left)
                        effectobjects(setobject).top = sizeform.height - (firstheight - sizeobjects(setobject).top)
                End Select
                effectobjects(setobject).Visible = True
            Next setobject
        End If
        '------------------------------------------
    End Sub
